open Int64
let (>>) f g x = g (f x)
let (-) = sub and (+) = add;;
let rec gcd a = function 0L -> a | b -> gcd b (rem a b)
let swap (a,b) = (b,a)

let make_stepper va vb na nb flip = 
  let step say = function
    | a, 0L -> (* bottom edge *) if say then Printf.printf "Fill up tank %c.\n" nb;        
        a, vb
    | a, b when a=va -> (* right edge*) if say then Printf.printf "Empty tank %c.\n" na;
        0L, b
    | 0L, b -> (* left edge*) if say then Printf.printf "Pour from %c to %c.\n" nb na;
        if b <= va then 
        b, 0L else
        va, b-va      
    | a, b when b=vb -> (* top edge *) if say then Printf.printf "Pour from %c to %c.\n" nb na;
        if a + b <= va then
        a+b, 0L else
        va, a + b - va 
    | ea,eb -> Printf.printf "bad state: (%Ld, %Ld) " ea eb; ea,eb  in  
  if flip then (fun say -> swap >> step say >> swap) else step;;

let solve va vb target =
  if va < 0L || vb < 0L || target < 0L then print_endline "Error: negative volumes!" else
  if target = 0L then print_endline "Take an empty tank. Done." else
  if va + vb = 0L || (va=0L && vb <> target) || (vb=0L && va<>target) then print_endline "Impossible!" else
  if va = 0L then
    (if vb = target then print_endline "Fill up tank B. Done." else print_endline "Impossible!") else
  if vb = 0L then
    (if va = target then print_endline "Fill up tank A. Done." else print_endline "Impossible!") else
  if target > max va vb then print_endline "Impossible!" else
  if rem target (gcd va vb) <> 0L then print_endline "No solution!" else
  let go1 = make_stepper va vb 'A' 'B' false and go2 = make_stepper vb va 'B' 'A' true in  
  let rec search_loop ab1 ab2 =
    let (a1,b1) = go1 false ab1 and (a2,b2) = go2 false ab2 in
    if a1 = target || b1 = target then go1 else
    if a2 = target || b2 = target then go2 else
    search_loop (a1,b1) (a2,b2)  in
  let stepper = search_loop (0L,0L) (0L,0L) in
  let rec print_loop ab = 
    let (a,b) = stepper true ab in
    Printf.printf "tank A: %Ld, tank B: %Ld\n" a b;
    if a = target || b = target then Printf.printf "Done!\n" else
    print_loop (a,b) in
  print_loop (0L, 0L);;   

if Array.length Sys.argv < 4 then 
  Printf.printf "Usage: %s <tank A volume> <tank B volume> <target volume>\n" Sys.argv.(0)
else
  let va = of_string Sys.argv.(1) and vb = of_string Sys.argv.(2) and trg = of_string Sys.argv.(3) in
  solve va vb trg;;